/*=============================================================================
	  ___________
	 /           \		Par Martin Robinson
	|   @#!$*%    |		logiciel libre GPL
	 \_______   _/
	 		 \ |  ___________
	    	  \| |   O   O   |
				 |  _______  |
				 | | | | | | |
===============================================================================
Preprocesseur
=============================================================================*/

#pragma once
#ifndef sdlMR_deja
#define sdlMR_deja
//#include "sdl/SDL.h"
#include "SDL/SDL.h"
#include <iostream>


using namespace std;

/*========
fonction*/

/*______________
initialisation*/

template <unsigned int w, unsigned int h>
SDL_Surface * commencer(const char * caption)
{
	SDL_Surface *ecran;
	if(SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO) == -1)	//evenement
	{
		cout << "Erreur lors de l'initialisation de la SDL", SDL_GetError();
		//exit( EXIT_FAILURE);
	}
	if(!(ecran = SDL_SetVideoMode(w,h,32,SDL_SWSURFACE | SDL_DOUBLEBUF)))
	{
		cout << "Erreur lors de l'initialisation de la surface desinable", SDL_GetError();
		//exit(EXIT_FAILURE);
	}
	SDL_WM_SetCaption(caption,NULL);
	return ecran;
}

/*_____________
fichier image*/

template <unsigned char _R, unsigned char _G, unsigned char _B>
SDL_Surface * ouvrireImage(const char *  nom)
{
	SDL_Surface * temporaire = SDL_LoadBMP(nom),
		        * optimale;
	Uint32 couleurInvisible;
	if (!temporaire)
	{
		cout << "porblme avec le fichier " << nom << endl;
		return 0;
	}
	optimale = SDL_DisplayFormat( temporaire );
	SDL_FreeSurface( temporaire );

	couleurInvisible = SDL_MapRGB( optimale->format, _R, _G, _B );
	SDL_SetColorKey( optimale, SDL_SRCCOLORKEY, couleurInvisible );

	return optimale;
}

/*________________
frame per second*/

template<unsigned int FPS>
void synchronizeMoi()
{
	static Uint32 next=0;
	Uint32 now = SDL_GetTicks();
	if (now<next)
		SDL_Delay(next-now);
	else
		next = now+(1000/FPS);
}

/*=====
objet*/

/*_________________
touche du clavier*/

template <class T>
class keyVector
{
	T _magnitude;
public:
	bool up,
		 down,
		 left,
		 right;
	keyVector(T magnitude);
	T x();
	T y();
};

template <class T>
keyVector<T>::keyVector(T magnitude)
{
	up = down = left = right = 0;
	_magnitude = magnitude;
}

template <class T>
T keyVector<T>::x()
{
	if (left && !right)
		return -_magnitude;
	else if (!left && right)
		return _magnitude;
	else
		return 0;
}

template <class T>
T keyVector<T>::y()
{
	if (up && !down)
		return -_magnitude;
	else if (!up && down)
		return _magnitude;
	else
		return 0;
}


/*___________________
collision detection*/
//template <int vx,int vy>
//bool pixelCollide(int x, int y, SDL_Rect & rect)
//{
//	x+=vx;
//	y+=vy;
//	return x<rect.x+rect.w &&
//		   y<rect.y+rect.h &&
//		   x>rect.x &&
//		   y<rect.y;
//}
//
//template <int vx, int vy>
//bool rectCollide(SDL_Rect a, SDL_Rect & b)
//{
//	int x = a.x+vx,
//		y = a.y+vy;
//	return pixelCollide<vx,vy>(x,y,b) ||
//		   pixelCollide<vx,vy>(x+a.w, y, b) ||
//		   pixelCollide<vx,vy>(x, y+a.h, b) ||
//		   pixelCollide<vx,vy>(x+a.w, y+a.h, b);
//}

#endif
